[luogu]P3572 [POI2014]PTA-Little Bird(单调队列)

Posted hhh1109

tags:

篇首语:本文由小常识网(cha138.com)小编为大家整理,主要介绍了[luogu]P3572 [POI2014]PTA-Little Bird(单调队列)相关的知识,希望对你有一定的参考价值。

P3572 [POI2014]PTA-Little Bird

题目描述

In the Byteotian Line Forest there are nn trees in a row.

On top of the first one, there is a little bird who would like to fly over to the top of the last tree.

Being in fact very little, the bird might lack the strength to fly there without any stop.

If the bird is sitting on top of the tree no. i, then in a single flight leg it can fly toany of the trees no. i+1,i+2,cdots,i+ki+1,i+2,?,i+k, and then has to rest afterward.

Moreover, flying up is far harder to flying down. A flight leg is tiresome if it ends in a tree at leastas high as the one where is started. Otherwise the flight leg is not tiresome.

The goal is to select the trees on which the little bird will land so that the overall flight is leasttiresome, i.e., it has the minimum number of tiresome legs.

We note that birds are social creatures, and our bird has a few bird-friends who would also like to getfrom the first tree to the last one. The stamina of all the birds varies,so the bird‘s friends may have different values of the parameter kk.

Help all the birds, little and big!

从1开始,跳到比当前矮的不消耗体力,否则消耗一点体力,每次询问有一个步伐限制,求每次最少耗费多少体力

输入输出格式

输入格式:

There is a single integer nn (2le nle 1?000?0002≤n≤1 000 000) in the first line of the standard input:

the number of trees in the Byteotian Line Forest.

The second line of input holds nn integers d_1,d_2,cdots,d_nd1?,d2?,?,dn? (1le d_ile 10^91≤di?≤109)separated by single spaces: d_idi? is the height of the i-th tree.

The third line of the input holds a single integer qq (1le qle 251≤q≤25): the number of birds whoseflights need to be planned.

The following qq lines describe these birds: in the ii-th of these lines, there is an integer k_iki? (1le k_ile n-11≤ki?≤n?1) specifying the ii-th bird‘s stamina. In other words, the maximum number of trees that the ii-th bird can pass before it has to rest is k_i-1ki??1.

输出格式:

Your program should print exactly qq lines to the standard output.

In the ii-th line, it should specify the minimum number of tiresome flight legs of the ii-th bird.

输入输出样例

输入样例#1: 复制

9
4 6 3 6 3 7 2 6 5
2
2
5

输出样例#1: 复制

2
1

说明

从1开始,跳到比当前矮的不消耗体力,否则消耗一点体力,每次询问有一个步伐限制,求每次最少耗费多少体力

题解

单调队列优化dp的经典题吧
先上(O(n^2))方程
(F[i]=min(F[j]+(h[j]<=h[i]));)
很显然我们用贪心的思想。
对于 (F[i]) 来说,从越小的 (F[j]) 跳过来越好。
对于 (h[i]) 来说,在单调队列里面留下越大的 (h[j]) 越好
同时, (F[i]) 的单调性显然要优先于 (h[i]) 的单调性。
用单调队列维护两个单调性即可
以上((j<i))

Code

#include<cstdio>
#include<cstring>
#include<algorithm>
#include<iostream>
#include<cmath>
using namespace std;
const int N=1e6+5;
int m,f[N],k,n,ch[N],q[N];
int read(){
    int x=0,w=1;char ch=getchar();
    while(ch>'9'||ch<'0'){if(ch=='-')w=-1;ch=getchar();}
    while(ch>='0'&&ch<='9')x=x*10+ch-'0',ch=getchar();
    return x*w;
}

bool cmp(int x,int y){
    return f[x]==f[y]?ch[x]>ch[y]:f[x]<f[y];
}

void solve(){
    k=read();
    memset(f,127/3,sizeof(f));f[1]=0;//ch[0]=1e9+1;
    int h=1,t=1;q[1]=1;
    for(int i=2;i<=n;i++){
        /*for(int j=max(0,i-k);j<i;j++){
        f[i]=min(f[i],f[j]+(ch[j]<=ch[i]));
        cout<<i<<' '<<f[i]<<endl;*/
        while(h<=t&&q[h]<i-k)h++;
        f[i]=f[q[h]]+(ch[q[h]]<=ch[i]);
        while(h<=t&&cmp(i,q[t]))t--;
        q[++t]=i;
    }
    cout<<f[n]<<endl;
}

int main(){
    n=read();
    for(int i=1;i<=n;i++)ch[i]=read();
    m=read();
    while(m--)solve();
    return 0;
}

以上是关于[luogu]P3572 [POI2014]PTA-Little Bird(单调队列)的主要内容,如果未能解决你的问题,请参考以下文章

luogu P3572 [POI2014]PTA-Little Bird 单调队列优化dp

luogu P3572 [POI2014]PTA-Little Bird 单调队列优化dp

P3572 [POI2014]PTA-Little Bird

[POI 2014]PTA-Little Bird

luogu P3567 [POI2014]KUR-Couriers

Luogu P3567 [POI2014]KUR-Couriers